=== doc/requirements.txt ===
-e git+https://github.com/JuliaLang/JuliaDoc.git#egg=JuliaDoc
