=== deps/Rmath/Makefile ===
all:
	make -C src

clean:
	make -C src clean
