=== debian/changelog ===
julia (0.2.1+dfsg-2) unstable; urgency=medium

  * readline-6.3.patch: new patch, fixes FTBFS against readline 6.3.
    (Closes: #741824)
  * Restrict supported archs to amd64 and i386, it never compiled elsewhere.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 16 Mar 2014 16:25:21 +0100

julia (0.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 15 Feb 2014 21:31:41 +0100

julia (0.2.0+dfsg-6) unstable; urgency=medium

  * Transition to libunwind8-dev. (Closes: #730464)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 01 Feb 2014 10:18:04 +0100

julia (0.2.0+dfsg-5) unstable; urgency=low

  * Transition to suitesparse 4.2.1.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 02 Dec 2013 18:38:37 +0100

julia (0.2.0+dfsg-4) unstable; urgency=low

  * Make the parallel.jl test non-fatal.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 24 Nov 2013 15:14:50 +0100

julia (0.2.0+dfsg-3) unstable; urgency=low

  * testsuite-i386.patch: loosen the numerical precision for yet another test.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 17 Nov 2013 19:32:52 +0100

julia (0.2.0+dfsg-2) unstable; urgency=low

  * testsuite-i386.patch: new patches, fixes FTBFS on i386.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 17 Nov 2013 17:51:13 +0100

julia (0.2.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: reflect upstream changes
  * Update patches:
    + remove patches applied upstream:
      - suitesparse-3.4.patch
      - testsuite-i386.patch
    + remove fhs.patch, and replace it by the SYSCONFDIR build option.
    + sysconfdir-install.patch: new patch to make the SYSCONFDIR option work
      for us.
    + refresh other patches.
  * Bump Standards-Version to 3.9.5, no changes needed.
  * Dependency of julia-dbg on julia is now versioned.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 17 Nov 2013 12:10:10 +0100

julia (0.2.0~rc2+dfsg-2) unstable; urgency=low

  * Use (older) suitesparse 3.4.
     + d/control: downgrade (build-)dependencies
     + use-sonames-with-dlopen.patch: update sonames
     + suitesparse-3.4.patch: new patch
  * Downgrade build-dependency to libunwind7-dev (was libunwind8-dev).
    libunwind8-dev is unlikely to merge to testing soon.
  * unversioned-system-load-path.patch: new patch.
    Drops version number from system load path. Versioning unnecessary since
    this path is managed by dpkg/apt. Moreover, it would make transitions to
    higher versions needlessly complicated.
  * testsuite-i386.patch: new patch, fixes testsuite crash on i386.
  * Use canonical URL for Vcs-* fields

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 03 Nov 2013 16:00:08 +0100

julia (0.2.0~rc2+dfsg-1) experimental; urgency=low

  * New upstream release candidate
  * Link dynamically against LLVM, this seems to now work correctly

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 26 Oct 2013 04:33:44 +0000

julia (0.2.0~rc1+dfsg-1) experimental; urgency=low

  * New upstream release candidate
  * Removed patches:
    + do-not-download-jquery.patch
    + fix-version.patch
    + no-webrepl.patch
    + suitesparse-3.4.patch
    + use-system-double-conversion.patch
    + zlib-1.2.8.patch
  * Added patches:
    + fhs.patch
    + no-debug-version.patch
    + verbose-build.patch
  * Ship upstream manpage
  * Ship NEWS.md
  * Build depend on llvm-3.3-dev
  * Build depend on libsuitesparse-dev >= 1:4.2.1
  * Stop distributing PDF documentation, it currently does not build
  * debian/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 16 Oct 2013 15:54:13 +0200
